/* 
 * assert.h
 *
 * Define the assert macro for debug output.
 *
 * This header file is meant for use with CRTDLL.DLL as included with
 * Windows 95(tm) and Windows NT(tm). In conjunction with other versions
 * of the standard C library things may or may not work so well.
 *
 * Contributors:
 *  Created by Colin Peters <colin@bird.fu.is.saga-u.ac.jp>
 *  Modified for use with msvcrt.dll by jeffdbREMOVETHIS@goodnet.com
 *
 *  THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain. You may
 *  use, modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but
 *  WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 *  DISCLAMED. This includes but is not limited to warranties of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef _ASSERT_H_
#define	_ASSERT_H_

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef NDEBUG

//If not debugging, assert does nothing
#define assert(x)	((void)0);

#else //debugging enabled

// msvcrt.dll supplies a function which does the actual output/call to abort.
void 	_assert (void* szExpression, void* szFileName, unsigned int nLine)
#ifdef	__GNUC__
	__attribute__ ((__noreturn__, __cdecl__))
#endif
	;

// Definition of the assert macro
#define assert(x) (void)((x) || (_assert( #x , __FILE__, __LINE__), 0) );
#endif // NDEBUG

#ifdef	__cplusplus
}
#endif

#endif
