/*
 * dir.h
 *
 * Functions for working with directories and path names.
 *
 * This header file is meant for use with CRTDLL.DLL as included with
 * Windows 95(tm) and Windows NT(tm). In conjunction with other versions
 * of the standard C library things may or may not work so well.
 *
 * Contributors:
 *  Created by Colin Peters <colin@bird.fu.is.saga-u.ac.jp>
 *  Modified for use with msvcrt.dll by jeffdbREMOVETHIS@goodnet.com
 *
 *  THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain. You may
 *  use, modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but
 *  WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 *  DISCLAMED. This includes but is not limited to warranties of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef _STRICT_ANSI

#ifndef _DIR_H_
#define	_DIR_H_

#ifdef	__cplusplus
extern "C" {
#endif

char*	_getcwd (char* caBuffer, int nBufferSize);
int	_mkdir (const char* szPath);
char*	_mktemp( char *dirtemplate );
int	_rmdir (const char* szPath);


char*	getcwd (char* caBuffer, int nBufferSize);
int	mkdir (const char* szPath);
char*	mktemp( char *dirtemplate );
int	rmdir (const char* szPath);

#ifdef _WIN32_WINNT
#define __need_wchar_t
#include <stddef.h>
wchar_t*	_wgetcwd( wchar_t *buffer, int maxlen );
int 		_wmkdir( const wchar_t *dirname );
wchar_t*	_wmktemp( wchar_t *template );
int 		_wrmdir( const wchar_t *dirname );
#endif


#ifdef	__cplusplus
}
#endif

#endif	/* Not _DIR_H_ */

#endif	/* Not _STRICT_ANSI */
