/*
 * direct.h
 *
 * Functions for manipulating paths and directories (included from dir.h)
 * plus functions for setting the current drive.
 *
 * This header file is meant for use with CRTDLL.DLL as included with
 * Windows 95(tm) and Windows NT(tm). In conjunction with other versions
 * of the standard C library things may or may not work so well.
 *
 * Contributors:
 *  Created by Colin Peters <colin@bird.fu.is.saga-u.ac.jp>
 *  Modified for use with msvcrt.dll by jeffdbREMOVETHIS@goodnet.com
 *
 *  THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain. You may
 *  use, modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but
 *  WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 *  DISCLAMED. This includes but is not limited to warranties of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef _STRICT_ANSI

#ifndef	_DIRECT_H_
#define	_DIRECT_H_

#include <dir.h>

#ifdef	__cplusplus
extern "C" {
#endif

/*
 * From aboutbox.cpp
 * win32 DWORD == unsigned long
 * returns int unsigned? yes!!
 */

struct _diskfree_t
{
unsigned int total_clusters; /* this is right per chkdsk */
unsigned int avail_clusters;
unsigned int sectors_per_cluster;
unsigned int bytes_per_sector;
};


/*
 * You really shouldn't be using these. Use the Win32 API functions instead.
 * However, it does make it easier to port older code.
 */


int     _chdir( const char *dirname );
int	_chdrive (int nDrive);
char*	_getdcwd (int nDrive, char* caBuffer, int nBufLen);
int	_getdrive();
unsigned long _getdrives();
unsigned int _getdiskfree(unsigned int nDrive, struct _diskfree_t *);
int     chdir( const char *dirname );

#ifdef _WIN32_WINNT
#define __need_wchar_t
#include <stddef.h>
int 	_wchdir( const wchar_t *dirname );
wchar_t *_wgetdcwd( int drive, wchar_t *buffer, int maxlen );
#endif

#ifdef	__cplusplus
}
#endif

#endif	/* Not _DIRECT_H_ */

#endif	/* Not _STRICT_ANSI */
