/*
 * excpt.h
 *
 * Define the exception handling macros for _try/_except()/_finally.
 *
 * This header file is meant for use with MSVCRT.DLL as included with
 * Windows 95(tm) and Windows NT(tm). In conjunction with other versions
 * of the standard C library things may or may not work so well.
 *
 * Contributors:
 *  Created by Mikey (jeffdb@netzone.com)
 *
 *  THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain. You may
 *  use, modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but
 *  WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 *  DISCLAMED. This includes but is not limited to warranties of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/* ----------------------------------------------------------------------------
	these structures are used by VC++ exception handling
	and except_handler3. untill gcc supports _try/_except/_finally
	directly the necessary #defs' are below,
	you must use msvcrt.dll, or write your own system
	level exception handling routine to use this ;^).

typedef struct _VC_EXCEPTION_REGISTRATION
{
unsigned long stan_stack;
unsigned long xcept_ptrs;
unsigned long prev;
unsigned long handler;
unsigned long *tbl_ptr;
unsigned long trylevel;
// unsigned long _ebp;
} VC_EXCEPTION_REGISTRATION;

typedef struct _EXCEPTION_REGISTRATION
{
FARPROC *prev; // pointer to previous EXCEPTION_REGISTRATION
FARPROC handler; // address of current _except_handler function
} EXCEPTION_REGISTRATION; //basic OS provided exception handling
				//must be built on stack
				//and registered at %fs:0
typedef struct _SCOPETABLE
{
DWORD previousTryLevel;
FARPROC lpfnFilter; // address of filter function for this _try/_except
FARPROC lpfnHandler; // address of _except _except_handler3 returns here
		     // if EXCEPTION_EXECUTE_HANDLER in filter function
} SCOPETABLE; // structure for handling nested exceptions

EXCEPTION_DISPOSITION __cdecl except_handler(
struct _EXCEPTION_RECORD *ExceptionRecord,
void * EstablisherFrame,
struct _CONTEXT *ContextRecord,
void * DispatcherContext
); // write your own exception handlers for SetUnhandledExceptionFilter
//    using this prototype

This header file is a kludge to add _try/_except _try/finally frame based 
exception handling to gcc, at the begining are some of the 
structures/functions that would be used, if this were written in c, 
however in order to implement this
I had to use a bastard combination of c, inline functions, assembly and extended
assembly and conditional assembly.

WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING

You must compile with -fomit-frame-pointer -O0 for this to work
the ld options --heap and --stack seam to cause problems. (and are not needed)

also the variables 
__xcpt_happened	__xcpt_filter_result __xcpt[ 1-7 ]

are instantiated here, for each function that uses _try/_except _try/_finally

use the macro _SXV( )
in EACH FUNCTION that contains a _try block immediatly before local variables
are declared, like this

int main()
{
_SXV(
int your, variables;
DWORD This_is_a_var = 99;
)

You will need to use the macro _END_FINALLY before the
end of any _finally blocks

_finally
{
free(MYSTUFF);
_END_FINALLY
}

RpcEndFinally is predefined, you don't need to use _END_FINALLY with it.

also the macros RpcExceptionCode() and GetExceptionCode() return
their values in __xcpt7.

GetExceptionInformation() returns in
__xcpt5, which is an LPEXCEPTION_POINTERS type variable.
*/


#ifndef _EXCPT_H_
#define _EXCPT_H_


#ifdef __cplusplus
extern "C" {
#endif

#ifndef RC_INVOKED

#define EH_NONCONTINUABLE	0x01
#define EH_UNWINDING		0x02
#define EH_EXIT_UNWIND		0x04
#define EH_STACK_INVALID	0x08
#define EH_NESTED_CALL		0x10

#define EXCEPTION_EXECUTE_HANDLER	1
#define EXCEPTION_CONTINUE_EXECUTION   -1
#define EXCEPTION_CONTINUE_SEARCH       0

typedef enum {
    ExceptionContinueExecution,
    ExceptionContinueSearch,
    ExceptionNestedException,
    ExceptionCollidedUnwind
} EXCEPTION_DISPOSITION;


struct _EXCEPTION_RECORD;
struct _CONTEXT;

extern EXCEPTION_DISPOSITION __cdecl _except_handler3(
struct _EXCEPTION_RECORD *ExceptionRecord, void * EstablisherFrame,
struct _CONTEXT *ContextRecord, void * DispatcherContext );

int _abnormal_termination(void);

#define AbnormalTermination         _abnormal_termination
#define abnormal_termination        _abnormal_termination

// vc++ generated functions

#define GetExceptionInformation() \
__xcpt5

#define _END_FINALLY \
if (__xcpt_happened) { \
__asm__ __volatile__( \
"movl -4(%%ebp),%%eax\n\t" \
"movl -8(%%ebp),%%ebx\n\t" \
"incl %%eax\n\t" \
"imul $12,%%eax\n\t" \
"movl 4(%%ebx,%%eax,1),%%esp\n\t" \
"xorl %%eax,%%eax\n\t" \
"ret\n\t": : : "%eax", "%ebx" ); }
	 

#define RpcEndFinally	_END_FINALLY }

#define GetExceptionCode()	\
({__asm__(\
"movl -0x14(%%ebp),%0\n\t"\
"movl (%0),%0\n\t"\
"movl (%0),%0\n\t"\
: "=r" (__xcpt7)); __xcpt7;})

#define RpcExceptionCode() GetExceptionCode()

//the above macros are only usable inside _try/_except block
//gcc will not generate a warning if these are used
//outside the _except block, but you will get garbage results

#define _SXV(args...) \
int __volatile__ __xcpt1 __attribute__((__unused__));\
void __volatile__ *__xcpt2 __attribute__((__unused__));\
void __volatile__ *__xcpt3 __attribute__((__unused__));\
void __volatile__ *__xcpt4 __attribute__((__unused__));\
LPEXCEPTION_POINTERS __volatile__ *__xcpt5 __attribute__((__unused__));\
void __volatile__ *__xcpt6 __attribute__((__unused__));\
int __volatile__ __xcpt_filter_result __attribute__((__unused__));\
int __volatile__ __xcpt_happened __attribute__((__unused__));\
unsigned int __volatile__ __xcpt7 __attribute__((__unused__));## args \
__asm__ __volatile__(\
"addl $4,%0\n\t"\
"movl %0,%%ebp\n\t"\
"movl $-1,-4(%%ebp)\n\t"\
"movl $__except_handler3,-12(%%ebp)\n\t"\
"movl %%fs:0,%0\n\t"\
"movl %0,-16(%%ebp)\n\t"\
"leal -16(%%ebp),%0\n\t"\
"movl %0,%%fs:0\n\t"\
"movl %%esp,-24(%%ebp)\n\t"\
: : "r" (&__xcpt1) : "memory" );




#define try \
	__asm__ __volatile__(\
	".ifndef __zero_try /* BEGIN_TRY */\n\t"\
	"__zero_try=1\n\t"\
	"__first_try=0\n\t"\
	"__second_try=0\n\t"\
	"__third_try=0\n\t"\
	"__fourth_try=0\n\t"\
	"__last_try=0\n\t"\
	".endif\n\t"\
	".if (__zero_try)\n\t"\
	"pushl $60\n\t"\
	"call _malloc\n\t"\
	"addl $4,%%esp\n\t"\
	"cmpl $0,%%eax\n\t"\
	"je _abort\n\t"\
	"movl %%eax,-8(%%ebp)\n\t"\
	".endif\n\t"\
	"movl -4(%%ebp),%%ecx\n\t"\
	"movl -8(%%ebp),%%edx\n\t"\
        ".if (__fourth_try)\n\t"\
        "movl %%ecx,48(%%edx)\n\t"\
        "movl $8f,52(%%edx)\n\t"\
        "movl $9f,56(%%edx)\n\t"\
        "__fourth_try=0;__last_try=1\n\t"\
        ".endif\n\t"\
        ".if (__third_try)\n\t"\
        "movl %%ecx,36(%%edx)\n\t"\
        "movl $6f,40(%%edx)\n\t"\
        "movl $7f,44(%%edx)\n\t"\
        "__third_try=0;__fourth_try=1\n\t"\
        ".endif\n\t"\
        ".if (__second_try)\n\t"\
        "movl %%ecx,24(%%edx)\n\t"\
        "movl $4f,28(%%edx)\n\t"\
        "movl $5f,32(%%edx)\n\t"\
        "__second_try=0;__third_try=1\n\t"\
        ".endif\n\t"\
        ".if (__first_try)\n\t"\
        "movl %%ecx,12(%%edx)\n\t"\
        "movl $2f,16(%%edx)\n\t"\
        "movl $3f,20(%%edx)\n\t"\
        "__first_try=0;__second_try=1\n\t"\
        ".endif\n\t"\
	".if (__zero_try)\n\t"\
	"movl %%ecx,(%%edx)\n\t"\
	"movl $0f,4(%%edx)\n\t"\
	"movl $1f,8(%%edx)\n\t"\
	"__zero_try=0;__first_try=1\n\t"\
	".endif\n\t"\
	"incl -4(%%ebp)\n\t"\
	: : : /* END_TRY */ "memory" );\
 	if(1)



#define except(P) \
        __xcpt_happened = 0;\
        __asm__ __volatile__(\
        ".if (__first_try) /* BEGIN_EXCEPT */\n\tjmp 1f\n\t0:\n\t.endif\n\t"\
        ".if (__second_try)\n\tjmp 3f\n\t2:\n\t.endif\n\t"\
        ".if (__third_try)\n\tjmp 5f\n\t4:\n\t.endif\n\t"\
        ".if (__fourth_try)\n\tjmp 7f\n\t6:\n\t.endif\n\t"\
        ".if (__last_try)\n\tjmp 9f\n\t8:\n\t.endif\n\t"\
        "movl %esp,%esi\n\t"\
        "movl -24(%ebp),%esp\n\t");\
        __xcpt_filter_result = (P);\
        __asm__ __volatile__(\
        "cmpl $-1,%%eax\n\t"\
        "je .+11\n\t"\
        "incl %%ecx\n\t"\
        : "=a" (__xcpt_filter_result), "=c" (__xcpt_happened)\
        : "0" (__xcpt_filter_result), "c" (__xcpt_happened)\
        : "%ecx", "memory" );\
        __asm__ __volatile__(\
        "movl %esi,%esp\n\t"\
        "ret\n\t");\
        __asm__ __volatile__(\
        ".if (__first_try)\n\t"\
        "1:__zero_try=1;__first_try=0\n\t"\
        "pushl -8(%ebp)\n\t"\
        "call _free\n\t"\
        "addl $4,%esp\n\t"\
        ".endif\n\t"\
        ".if (__second_try)\n\t"\
        "3:__first_try=1;__second_try=0\n\t"\
        ".endif\n\t"\
        ".if (__third_try)\n\t"\
        "5:__second_try=1;__third_try=0\n\t"\
        ".endif\n\t"\
        ".if (__fourth_try)\n\t"\
        "7:__third_try=1;__fourth_try=0\n\t"\
        ".endif\n\t"\
        ".if (__last_try)\n\t"\
        "9:__fourth_try=1;__last_try=0\n\t"\
        ".endif\n\t"\
        "movl -24(%ebp),%esp\n\t"\
        "decl -4(%ebp)\n\t");\
        if(__xcpt_happened && (P))


#define finally \
        __xcpt_happened = 0;\
        __asm__ __volatile__(\
        ".if (__first_try) /* BEGIN_FINALLY */\n\tjmp 1f\n\t0:\n\t.endif\n\t"\
        ".if (__second_try)\n\tjmp 3f\n\t2:\n\t.endif\n\t"\
        ".if (__third_try)\n\tjmp 5f\n\t4:\n\t.endif\n\t"\
        ".if (__fourth_try)\n\tjmp 7f\n\t6:\n\t.endif\n\t"\
        ".if (__last_try)\n\tjmp 9f\n\t8:\n\t.endif\n\t");\
        __asm__ __volatile__(\
        "movl %esp,%esi\n\t"\
        "movl -24(%ebp),%esp\n\t");\
        __asm__ __volatile__(\
        "movl $1,%%eax\n\t"\
        "incl %%ecx\n\t"\
        : "=c" (__xcpt_happened)\
        : "c" (__xcpt_happened)\
        : "%ecx", "memory" );\
        __asm__ __volatile__(\
        "movl %esi,%esp\n\t"\
        "ret\n\t");\
        __asm__ __volatile__(\
        ".if (__first_try)\n\t"\
        "1:__zero_try=1;__first_try=0\n\t"\
        "pushl -8(%ebp)\n\t"\
        "call _free\n\t"\
        "addl $4,%esp\n\t"\
        ".endif\n\t"\
        ".if (__second_try)\n\t"\
        "3:__first_try=1;__second_try=0\n\t"\
        ".endif\n\t"\
        ".if (__third_try)\n\t"\
        "5:__second_try=1;__third_try=0\n\t"\
        ".endif\n\t"\
        ".if (__fourth_try)\n\t"\
        "7:__third_try=1;__fourth_try=0\n\t"\
        ".endif\n\t"\
        ".if (__last_try)\n\t"\
        "9:__fourth_try=1;__last_try=0\n\t"\
        ".endif\n\t"\
        "movl -4(%ebp),%eax\n\t"\
        "movl -8(%ebp),%ebx\n\t"\
        "imul $12,%eax\n\t"\
        "movl %esp,4(%ebx,%eax,1)\n\t"\
        "movl -24(%ebp),%esp\n\t"\
        "decl -4(%ebp)\n\t");\
        if(1)

#define _try try
#define __try try
#define __try__ try
#define _except except
#define __except except
#define __except__ except
#define _finally finally
#define __finally finally
#define __finally__ finally



#endif /* RC_INVOKED */

#ifdef __cplusplus
}
#endif

#endif /* _EXCPT_H_ */


/* KEEP THESE FOR REFERENCE JD */
/* #define _SETUP_TRY  \
int __xcpt_filter_result __attribute__((__unused__));\
int __xcpt_happened;\
EXCEPTION_REGISTRATION excpt_reg;\
__asm__ __volatile__(\
"movl %%eax,%%ebp\n\t"\
"addl $24,%%ebp\n\t"\
"movl $-1,-4(%%ebp)\n\t"\
"movl $__except_handler3,-12(%%ebp)\n\t"\
"movl %%fs:0,%%eax\n\t"\
"movl %%eax,-16(%%ebp)\n\t"\
"leal -16(%%ebp),%%eax\n\t"\
"movl %%eax,%%fs:0\n\t"\
"movl %%esp,-24(%%ebp)\n\t"\
 : : "a" ( &excpt_reg) : "%eax", "memory" ); */


/* #ifdef _CALLBACK_TRY
#undef _CALLBACK_TRY
__asm__ __volatile__(\
"0:movl $0b,%%edi\n\t"\
"pushl %%es\n\t"\
"pushl %%cs\n\t"\
"popl %%es\n\t"\
"movl $0xffff,%%ecx\n\t"\
"movl $0x5d,%%eax\n\t"\
"movl $0xc481,%%edx\n\t"\
"movl $0xc483,%%ebx\n\t"\
"cld\n\t"\
"1:repnz\n\t"\
"scasb\n\t"\
"jnz 2f\n\t"\
"cmpw %%bx,(%%edi)\n\t"\
"jz 3f\n\t"\
"cmpw %%dx,(%%edi)\n\t"\
"jnz 1b\n\t"\
"movw 2(%%edi),%%eax\n\t"\
"addl $6,%%edi\n\t"\
"addl $4,%%eax\n\t"\
"jmp 4f\n\t"\
"2:movl $2b,%%eax\n\t"\
"call _exit\n\t"\
"3:xorl %%eax,%%eax\n\t"\
"movb 2(%%edi),%%eax\n\t"\
"addl $8,%%eax\n\t"\
"addl $3,%%edi\n\t"\
"4:movl $0xc2,%%ebx\n\t"\
"cmpb %%bl,(%%edi)\n\t"\
"je 5f\n\t"\
"movl $0xca,%%ebx\n\t"\
"cmpb %%bl,(%%edi)\n\t"\
"jne 2b\n\t"\
"5:addw 1(%%edi),%%eax\n\t"\
"popl %%es\n\t"\
"movl %%esp,%%ebp\n\t"\
"addl %%eax,%%ebp\n\t"\
"movl %%eax,%%ecx\n\t"\
: : : "memory" );
#else
__asm__ __volatile__(\
"movl -24(%%ebp),%%ebp\n\t"\
"movl %%ebp,%%ecx\n\t"\
"subl %%esp,%%ecx\n\t"\
"movl %%ecx,%%eax\n\t"\
: : : "memory" );

#endif
__asm__ __volatile__(\
"movl %%esp,%%esi\n\t"\
"subl $92,%%esp\n\t"\
"movl %%ecx,%%eax\n\t"\
"movl %%esp,%%edi\n\t"\
"sar $2,%%ecx\n\t"\
"cld\n\t"\
"rep\n\t"\
"movsl %%ds:(%%esi),%%es:(%%edi)\n\t"\
"movl $-1,-4(%%ebp)\n\t"\
"leal  -92(%%ebp),%%edi\n\t"\
"movl %%edi,-8(%%ebp)\n\t"\
"movl $__except_handler3,-12(%%ebp)\n\t"\
"movl %%fs:0,%%edi\n\t"\
"movl %%edi,-16(%%ebp)\n\t"\
"leal -16(%%ebp),%%edi\n\t"\
"movl %%edi,%%fs:0\n\t"\
"movl %%esp,-24(%%ebp)\n\t"\
"movl %%eax,-28(%%ebp)\n\t"\
: : : "memory" );
*/

