/*
 * malloc.h
 *
 * Support for programs which want to use malloc.h to get memory management
 * functions. Unless you absolutely need some of these functions and they are
 * not in the ANSI headers you should use the ANSI standard header files
 * instead.
 *
 * This header file is meant for use with MSVCRT.DLL as included with
 * Windows 95(tm) and Windows NT(tm). In conjunction with other versions
 * of the standard C library things may or may not work so well.
 *
 * Contributors:
 *  Created by Colin Peters <colin@bird.fu.is.saga-u.ac.jp>
 *  Modified for use with msvcrt.dll by jeffdbREMOVETHIS@goodnet.com
 *
 *  THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain. You may
 *  use, modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but
 *  WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 *  DISCLAMED. This includes but is not limited to warranties of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */


#ifndef _MALLOC_H_
#define _MALLOC_H_

#ifdef	__cplusplus
extern "C" {
#endif

#define __need_size_t
#include <stddef.h>


void*   calloc  (size_t sizeObjCnt, size_t sizeObject);
void*   malloc  (size_t sizeObject);
void*   realloc (void* pObject, size_t sizeNew);
void*   free    (void* pObject);


#ifndef	__STRICT_ANSI__

#define _HEAP_MAXREQ	0xFFFFFFE0

// FIXME BADBEGIN BADNODE and EMPTY may be wrong
#define _HEAPBADBEGIN -3 // Initial header information invalid or not found
#define _HEAPBADNODE  -4 // Heap damaged or bad node found
#define _HEAPBADPTR   -6 // _HEAPINFO._pentry not valid pointer into heap 
#define _HEAPEND      -5 // End of heap reached successfully 
#define _HEAPEMPTY    -1 // Heap not initialized 
#define _HEAPOK       -2 // No errors so far _HEAPINFO has next entry.
// if an error occurs, _heapwalk sets errno to ENOSYS.
#define _FREEENTRY 0
#define _USEDENTRY 1

typedef struct
{
int *_pentry;
size_t _size;
int _useflag;
} _HEAPINFO;

void*	_expand( void *memblock, size_t size );
int 	_heapadd( void *memblock, size_t size );
int	_heapchk ();	/* Verify heap integrety. */
int	_heapmin ();	/* Return unused heap to the OS. */
int	_heapset (unsigned int unFill);
int 	_heapwalk( _HEAPINFO *entryinfo );
size_t  _heapused(size_t *, size_t *);
size_t	_msize (void* pBlock);

void    *alloca( size_t size );


unsigned int* __p__amblksiz();
#define _amblksiz (*__p__amblksiz())


#endif /* Not __STRICT_ANSI__ */

#ifdef __cplusplus
}
#endif

#endif /* Not _MALLOC_H_ */

