/* 
 * math.h
 *
 * Mathematical functions.
 *
 * This header file is meant for use with CRTDLL.DLL as included with
 * Windows 95(tm) and Windows NT(tm). In conjunction with other versions
 * of the standard C library things may or may not work so well.
 *
 * Contributors:
 *  Created by Colin Peters <colin@bird.fu.is.saga-u.ac.jp>
 *  Modified for use with msvcrt.dll by jeffdbREMOVETHIS@goodnet.com
 *
 *  THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain. You may
 *  use, modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but
 *  WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 *  DISCLAMED. This includes but is not limited to warranties of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef _MATH_H_
#define _MATH_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdlib.h>

extern double* _imp___HUGE;
#define HUGE_VAL	(*_imp___HUGE)

double _cdecl	acos (double x);
double _cdecl	asin (double x);
double _cdecl	atan (double x);
double _cdecl	atan2 (double y, double x);
double _cdecl	ceil (double x);
double _cdecl	cos (double x);
double _cdecl	cosh (double x);
double _cdecl	exp (double x);
double _cdecl	fabs (double x);
double _cdecl	floor (double x);
double _cdecl	fmod (double x, double y);
double _cdecl	frexp (double x, int* exp);
double _cdecl	ldexp (double x, int n);
double _cdecl	log (double x);
double _cdecl	log10 (double x);
double _cdecl	modf (double x, double* ip);
double _cdecl	pow (double x, double y);
double _cdecl	sin (double x);
double _cdecl	sinh (double x);
double _cdecl	sqrt (double x);
double _cdecl	tan (double x);
double _cdecl	tanh (double x);


#ifndef	__STRICT_ANSI__

struct _exception
{
	int	type; /* Exception type */
	char	*name; /* Name of function where error occured */
	double	arg1; /* First argument to function */
	double	arg2; /* Second argument (if any) to function */
	double	retval; /* Value to be returned by function */
};

int _cdecl _matherr ( struct _exception *except);

/*
 * Types for the above _exception structure.
 */

#define	_DOMAIN		1	/* domain error in argument */
#define	_SING		2	/* singularity */
#define	_OVERFLOW	3	/* range overflow */
#define	_UNDERFLOW	4	/* range underflow unsuported in win32*/
#define	_TLOSS		5	/* total loss of precision */
#define	_PLOSS		6	/* partial loss of precision */


/*
 * Exception types with non-ANSI names for compatibility.
 */

#define	DOMAIN		_DOMAIN
#define	SING		_SING
#define	OVERFLOW	_OVERFLOW
#define	UNDERFLOW	_UNDERFLOW
#define	TLOSS		_TLOSS
#define	PLOSS		_PLOSS

/* Complex number (for cabs) */
struct _complex
{
	double	x;	/* Real part */
	double	y;	/* Imaginary part */
};

double _cdecl	_cabs (struct _complex x);
double _cdecl	_hypot (double x, double y);
double _cdecl	_j0 (double x);
double _cdecl	_j1 (double x);
double _cdecl	_jn (int n, double x);
double _cdecl	_y0 (double x);
double _cdecl	_y1 (double x);
double _cdecl	_yn (int n, double x);
double _cdecl cabs (struct _complex x);
double _cdecl hypot (double x, double y);
double _cdecl j0 (double x);
double _cdecl j1 (double x);
double _cdecl jn (int n, double x);
double _cdecl y0 (double x);
double _cdecl y1 (double x);
double _cdecl yn (int n, double x);

#define _HUGE HUGE_VAL
#define HUGE _HUGE


#endif	/* Not 	__STRICT_ANSI__ */

#ifdef __cplusplus
}
#endif

#endif /* Not _MATH_H_ */
