/*
 * search.h
 *
 * Functions for working with binary searches/sorts
 *
 * This header file is meant for use with MSVCRT.DLL as included with
 * Windows 95(tm) and Windows NT(tm). In conjunction with other versions
 * of the standard C library things may or may not work so well.
 *
 * Contributors:
 *  Created by Mikey <jeffdb@netzone.com>
 *
 *  THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain. You may
 *  use, modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but
 *  WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 *  DISCLAMED. This includes but is not limited to warranties of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef _SEARCH_H_
#define _SEARCH_H_

#ifdef __cplusplus
extern "C" {
#endif

#define __need_size_t
#include <stddef.h>

typedef int _cdecl (*_pfunccmp_t)(const void*, const void*);

void    *bsearch ( const void *pKey, const void *pBase,
 size_t cntObjects, size_t sizeObject, 
 _pfunccmp_t pfuncCmp);

void    qsort   (const void* pBase, size_t cntObjects, size_t sizeObject,
                _pfunccmp_t pfuncCmp);

 

#ifdef __cplusplus
}
#endif

#endif /* _SEARCH_H_ */
