/*
 * locking.h
 *
 * Constants for the mode parameter of the locking function.
 *
 * This header file is meant for use with CRTDLL.DLL as included with
 * Windows 95(tm) and Windows NT(tm). In conjunction with other versions
 * of the standard C library things may or may not work so well.
 *
 * Contributors:
 *  Created by Colin Peters <colin@bird.fu.is.saga-u.ac.jp>
 *  Modified for use with msvcrt.dll by jeffdbREMOVETHIS@goodnet.com
 *
 *  THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain. You may
 *  use, modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but
 *  WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 *  DISCLAMED. This includes but is not limited to warranties of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#ifndef	_STRICT_ANSI
#ifndef	_LOCKING_H_
#define	_LOCKING_H_

#define _LK_LOCK 1 //Lock bytes retry once each second for 10 or return error
#define LK_LOCK _LK_LOCK
#define _LK_RLCK 3 // blocking write lock. any retry?
#define LK_RLCK _LK_RLCK
#define _LK_NBLCK 2 //Locks bytes immediate or function returns error.
#define LK_NBLCK _LK_NBLCK
#define _LK_NBRLCK 4 // nonblock lock for write? 
#define LK_NBRLCK _LK_NBRLCK
#define _LK_UNLCK 0 //Unlock bytes return error if not locked.
#define LK_UNLCK _LK_UNLCK

#endif	/* Not _LOCKING_H_ */
#endif	/* Not _STRICT_ANSI */
