/*
 * utime.h
 *
 * Support for the utime function.
 *
 * This header file is meant for use with CRTDLL.DLL as included with
 * Windows 95(tm) and Windows NT(tm). In conjunction with other versions
 * of the standard C library things may or may not work so well.
 *
 * Contributors:
 *  Created by Colin Peters <colin@bird.fu.is.saga-u.ac.jp>
 *  Modified for use with msvcrt.dll by jeffdbREMOVETHIS@goodnet.com
 *
 *  THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain. You may
 *  use, modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but
 *  WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 *  DISCLAMED. This includes but is not limited to warranties of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef	_STRICT_ANSI

#ifndef	_UTIME_H_
#define	_UTIME_H_

#include <sys/types.h>
#define __need_wchar_t
#include <stddef.h>

#ifdef	__cplusplus
extern "C" {
#endif

/*
 * Structure used by _utime function.
 */
struct _utimbuf
{
	time_t	actime;		/* Access time */
	time_t	modtime;	/* Modification time */
};

int	_utime (const char* szFileName, struct _utimbuf* pTimes);
int 	_futime( int handle, struct _utimbuf *filetime );
int     _wutime( wchar_t *filename, struct _utimbuf *times );

#ifndef	_NO_OLDNAMES

/* NOTE: Must be the same as _utimbuf above. */
struct utimbuf
{
	time_t	actime;
	time_t	modtime;
};

int	utime (const char* szFileName, struct utimbuf* pTimes);

#endif	/* Not _NO_OLDNAMES */


#ifdef	__cplusplus
}
#endif

#endif	/* Not _UTIME_H_ */
#endif	/* Not _STRICT_ANSI */
